import { IDisposable } from "../../Interfaces/IDisposable";
export declare class GlowManager implements IDisposable {
    private _zkScene;
    private _scene;
    private _sceneHelper;
    private _glowLayer;
    get enabled(): boolean;
    set enabled(value: boolean);
    get intensity(): number;
    set intensity(value: number);
    get blurSize(): number;
    set blurSize(value: number);
    constructor(zkScene: Zakeke.Scene, scene: BABYLON.Scene);
    dispose(): void;
    private destroyGlowLayer;
    private createOrUpdateGlowLayer;
    update(): void;
    turnOffGlow(): void;
    turnOnGlow(): void;
    private sanityCheck;
    isGlowEnabledForMesh(mesh: BABYLON.Mesh): boolean;
    enableGlowForMesh(mesh: BABYLON.AbstractMesh): void;
    disableGlowForMesh(mesh: BABYLON.AbstractMesh): void;
    private getGlowConfig;
    private getOrCreateGlowConfig;
}
