import { IDisposable } from '../../Interfaces/IDisposable';
import { BaseProceduralTexture } from './BaseProceduralTexture';
export declare class ForegroundBackgroundProceduralTexture extends BaseProceduralTexture implements IDisposable {
    static readonly FRAGMENT_SHADER = "zakeke_ForegroundBackgroundProceduralTexture";
    static readonly CUSTOM_TYPE = "Zakeke.ForegroundBackgroundProceduralTexture";
    private _foreColor;
    private _backColor;
    get foreColor(): BABYLON.Vector3;
    set foreColor(value: BABYLON.Vector3);
    get backColor(): BABYLON.Vector3;
    set backColor(value: BABYLON.Vector3);
    constructor(name: string, size: number, scene: BABYLON.Scene, baseTexture: BABYLON.Texture, fallbackTexture?: BABYLON.Texture, generateMipMaps?: boolean);
    dispose(): void;
    updateShaderUniforms(): void;
    /**
    * Render the texture to its associated render target.
    * @param useCameraPostProcess Define if camera post process should be applied to the texture
    */
    render(useCameraPostProcess?: boolean): void;
    /**
    * Resize the texture to new value.
    * @param size Define the new size the texture should have
    * @param generateMipMaps Define whether the new texture should create mip maps
    */
    resize(size: number, generateMipMaps: boolean): void;
}
