import { IDisposable } from '../../Interfaces/IDisposable';
import { BaseProceduralTexture } from './BaseProceduralTexture';
export declare class OpacityProceduralTexture extends BaseProceduralTexture implements IDisposable {
    static readonly FRAGMENT_SHADER = "zakeke_OpacityProceduralTexture";
    static readonly CUSTOM_TYPE = "Zakeke.OpacityProceduralTexture";
    private _opacity;
    get opacity(): number;
    set opacity(value: number);
    constructor(name: string, size: number, scene: BABYLON.Scene, baseTexture: BABYLON.Texture, blendTexture: BABYLON.Texture, fallbackTexture?: BABYLON.Texture, generateMipMaps?: boolean);
    dispose(): void;
    updateShaderUniforms(): void;
    /**
    * Render the texture to its associated render target.
    * @param useCameraPostProcess Define if camera post process should be applied to the texture
    */
    render(useCameraPostProcess?: boolean): void;
    /**
      * Resize the texture to new value.
      * @param size Define the new size the texture should have
      * @param generateMipMaps Define whether the new texture should create mip maps
      */
    resize(size: number, generateMipMaps: boolean): void;
}
