import { IDisposable } from "../../Interfaces/IDisposable";
type BlobInfo = {
    name: string;
    blob: Blob;
};
export declare class SceneToBlobs implements IDisposable {
    private _workerPoolPromise?;
    /**
     * Default number of workers to create when splitting files
     */
    static DefaultNumWorkers: number;
    private static GetDefaultNumWorkers;
    private static _Default;
    /**
     * Default instance for the draco compression object.
     */
    static get Default(): SceneToBlobs;
    /**
 * Constructor
 * @param numWorkers The number of workers for async operations. Specify `0` to disable web workers and run synchronously in the current context.
*/
    constructor(numWorkers?: number);
    dispose(): void;
    /**
 * Returns a promise that resolves when ready. Call this manually to ensure draco compression is ready before use.
 * @returns a promise that resolves when ready
 */
    whenReadyAsync(): Promise<void>;
    getSceneBlobsAsync(json: string, version: number, onProgress: (perc: number) => void): Promise<BlobInfo[]>;
}
export {};
