import React, { FunctionComponent } from 'react';
import { TryOnGenericFineTuningSettings, TryOnProduct, TryOnProvider, TryOnSeller, TryOnType } from '../../models';
import { ZakekeTryOnExposedMethods } from './tryOnModels';
export interface ZakekeTryOnViewerProps {
    children?: React.ReactNode;
    className?: string;
    switchable?: boolean;
    onPDUpdated: (pd: number) => void;
    onReady?: () => void;
    onLoaded?: () => void;
    onClose: () => void;
    onWebcamError: () => void;
}
export declare const ZakekeTryOnViewer: React.ForwardRefExoticComponent<ZakekeTryOnViewerProps & React.RefAttributes<ZakekeTryOnExposedMethods>>;
export interface TryOnViewProps {
    className?: string;
    provider: TryOnProvider;
    type: TryOnType;
    obj: Blob;
    settings?: TryOnGenericFineTuningSettings;
    product: TryOnProduct;
    customer: TryOnSeller;
    onReady?: () => void;
    onLoaded?: () => void;
    onClose: () => void;
    onPDUpdated?: (pd: number) => void;
    onWebcamError: () => void;
}
export declare const TryOnView: FunctionComponent<TryOnViewProps>;
export interface PupillaryDistanceViewProps {
    className?: string;
    provider: TryOnProvider;
    product: TryOnProduct;
    customer: TryOnSeller;
    onReady?: () => void;
    onLoaded?: () => void;
    onPDUpdated?: (pd: number) => void;
    onClose: () => void;
    onWebcamError: () => void;
}
export declare const PupillaryDistanceView: FunctionComponent<PupillaryDistanceViewProps>;
