export type PriceStructure = "CUSTOMIZATION_PRICE" | "FINAL_PRICE" | "SEPARATED_PRICES";
export type pricing_model = {
    readonly id: string;
    readonly pricingID: number;
    readonly pricingName: string | null;
    readonly description: string | null;
    readonly priceDescriptionEnabled: boolean | null;
    readonly priceStructure: PriceStructure | null;
    readonly infoPricingText: string | null;
    readonly printTypes: ReadonlyArray<{
        readonly printTypeID: number;
        readonly printTypeName: string | null;
    }>;
    readonly products: ReadonlyArray<{
        readonly productID: number;
        readonly productName: string | null;
    }>;
    readonly rules: ReadonlyArray<{
        readonly allMatchType: boolean;
        readonly elementID: number;
        readonly elementTitle: string | null;
        readonly isSetupPrice: boolean;
        readonly propertyID: number;
        readonly ruleID: number;
        readonly priceType: number;
        readonly conditions: ReadonlyArray<{
            readonly conditionID: number;
            readonly formula: string | null;
            readonly position: number;
            readonly priceToAdd: unknown;
            readonly quantity: number;
        } | null> | null;
        readonly targets: ReadonlyArray<{
            readonly area: string | null;
            readonly color: string | null;
            readonly side: string | null;
            readonly targetID: number;
        } | null> | null;
    }>;
};
